Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class SecureClassLoader

    java.lang.Object
      |
      +--java.lang.ClassLoader
            |
            +--java.security.SecureClassLoader

Direct Known Subclasses:
  URLClassLoader

public class SecureClassLoader
extends ClassLoader

This class extends ClassLoader with additional support for defining classes with an associated code source and permissions which are retrieved by the system policy by default.

Constructor Summary
`protected` | `SecureClassLoader()` Creates a new SecureClassLoader using the default parent class loader for delegation.
`protected` | `SecureClassLoader(ClassLoader parent)` Creates a new SecureClassLoader using the specified parent class loader for delegation.

Method Summary
`protected Class` | `defineClass(String name, byte[] b, int off, int len, CodeSource cs)` Converts an array of bytes into an instance of class Class, with an optional CodeSource.
`protected PermissionCollection` | `getPermissions(CodeSource codesource)` Returns the permissions for the given CodeSource object.

Methods inherited from class java.lang.ClassLoader
`defineClass, defineClass, defineClass, definePackage, findClass, findLibrary, findLoadedClass, findResource, findResources, findSystemClass, getPackage, getPackages, getParent, getResource, getResourceAsStream, getResources, getSystemClassLoader, getSystemResource, getSystemResourceAsStream, getSystemResources, loadClass, loadClass, resolveClass, setSigners`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SecureClassLoader

    protected SecureClassLoader(ClassLoader parent)

  Creates a new SecureClassLoader using the specified parent class loader for delegation.

  If there is a security manager, this method first calls the security manager's `checkCreateClassLoader` method to ensure creation of a class loader is allowed.

  Parameters:
    `parent` - the parent ClassLoader
  Throws:
    `SecurityException` - if a security manager exists and its `checkCreateClassLoader` method doesn't allow creation of a class loader.
  See Also:
    `SecurityManager.checkCreateClassLoader()`

### SecureClassLoader

    protected SecureClassLoader()

  Creates a new SecureClassLoader using the default parent class loader for delegation.

  If there is a security manager, this method first calls the security manager's `checkCreateClassLoader` method to ensure creation of a class loader is allowed.

  Throws:
    `SecurityException` - if a security manager exists and its `checkCreateClassLoader` method doesn't allow creation of a class loader.
  See Also:
    `SecurityManager.checkCreateClassLoader()`

Method Detail

### defineClass

    protected final Class defineClass(String name,
                                      byte[] b,
                                      int off,
                                      int len,
                                      CodeSource cs)

  Converts an array of bytes into an instance of class Class, with an optional CodeSource. Before the class can be used it must be resolved.

  If a non-null CodeSource is supplied and a Policy provider is installed, Policy.getPermissions() is invoked in order to associate a ProtectionDomain with the class being defined.

  Parameters:
    `name` - the name of the class
    `b` - the class bytes
    `off` - the start offset of the class bytes
    `len` - the length of the class bytes
    `cs` - the associated CodeSource, or null if none
  Returns:
    the `Class` object created from the data, and optional CodeSource.

### getPermissions

    protected PermissionCollection getPermissions(CodeSource codesource)

  Returns the permissions for the given CodeSource object. The default implementation of this method invokes the java.security.Policy.getPermissions method to get the permissions granted by the policy to the specified CodeSource.

  This method is invoked by the defineClass method which takes a CodeSource as an argument when it is constructing the ProtectionDomain for the class being defined.

  The constructed ProtectionDomain is cached by the SecureClassLoader. The contents of the cache persist for the lifetime of the SecureClassLoader instance. This persistence inhibits Policy.refresh() from influencing the protection domains already in the cache for a given CodeSource.

  Parameters:
    `codesource` - the codesource.
  Returns:
    the permissions granted to the codesource.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.